package org.simantics.db.tests.api.readGraph;

import org.junit.BeforeClass;
import org.junit.runner.RunWith;
import org.junit.runners.Suite.SuiteClasses;
import org.simantics.db.common.utils.Logger;
import org.simantics.db.testing.common.RegressionSuiteRunner;
import org.simantics.db.testing.common.Tests;
import org.simantics.db.tests.api.readGraph.adapt.AdaptTest3;
import org.simantics.db.tests.api.readGraph.adapt.AdaptTest4;
import org.simantics.db.tests.api.readGraph.adapt.AdaptionFailureTest;
import org.simantics.db.tests.api.readGraph.adaptRelated.AdaptRelatedTest2;
import org.simantics.db.tests.api.readGraph.adaptRelated.AdaptRelatedTest3;
import org.simantics.db.tests.api.readGraph.adaptUnique.AdaptUniqueTest2;
import org.simantics.db.tests.api.readGraph.forEachObject.ForEachObjectTest1;
import org.simantics.db.tests.api.readGraph.forObjectSet.ForObjectSetTest1;
import org.simantics.db.tests.api.readGraph.getAssertedObjects.GetAssertedObjectsTest1;
import org.simantics.db.tests.api.readGraph.getAssertedObjects.GetAssertedObjectsTest2;
import org.simantics.db.tests.api.readGraph.getAssertedObjects.GetAssertedObjectsTest3;
import org.simantics.db.tests.api.readGraph.getAssertedObjects.GetAssertedObjectsTest4;
import org.simantics.db.tests.api.readGraph.getAssertedObjects.GetAssertedObjectsTest5;
import org.simantics.db.tests.api.readGraph.getAssertedObjects.GetAssertedObjectsTest6;
import org.simantics.db.tests.api.readGraph.getAssertedObjects.GetAssertedObjectsTest7;
import org.simantics.db.tests.api.readGraph.getAssertedStatements.GetAssertedStatementsTest1;
import org.simantics.db.tests.api.readGraph.getAssertedStatements.GetAssertedStatementsTest2;
import org.simantics.db.tests.api.readGraph.getAssertedStatements.GetAssertedStatementsTest3;
import org.simantics.db.tests.api.readGraph.getAssertedStatements.GetAssertedStatementsTest4;
import org.simantics.db.tests.api.readGraph.getAssertedStatements.GetAssertedStatementsTest5;
import org.simantics.db.tests.api.readGraph.getAssertedStatements.GetAssertedStatementsTest6;
import org.simantics.db.tests.api.readGraph.getAssertedStatements.GetAssertedStatementsTest7;
import org.simantics.db.tests.api.readGraph.getBuiltin.GetBuiltinTest1;
import org.simantics.db.tests.api.readGraph.getInverse.GetInverseTest1;
import org.simantics.db.tests.api.readGraph.getInverse.GetInverseTest2;
import org.simantics.db.tests.api.readGraph.getInverse.GetInverseTest3;
import org.simantics.db.tests.api.readGraph.getInverse.GetInverseTest4;
import org.simantics.db.tests.api.readGraph.getObjects.GetObjectsTest1;
import org.simantics.db.tests.api.readGraph.getObjects.GetObjectsTest21;
import org.simantics.db.tests.api.readGraph.getObjects.GetObjectsTest22;
import org.simantics.db.tests.api.readGraph.getObjects.GetObjectsTest3;
import org.simantics.db.tests.api.readGraph.getObjects.GetObjectsTest4;
import org.simantics.db.tests.api.readGraph.getObjects.GetObjectsTest5;
import org.simantics.db.tests.api.readGraph.getObjects.GetObjectsTest6;
import org.simantics.db.tests.api.readGraph.getObjects.GetObjectsTest7;
import org.simantics.db.tests.api.readGraph.getObjects.GetObjectsWithAssertionsTest3;
import org.simantics.db.tests.api.readGraph.getObjects.GetObjectsWithAssertionsTest6;
import org.simantics.db.tests.api.readGraph.getObjects.GetObjectsWithAssertionsTest7;
import org.simantics.db.tests.api.readGraph.getPossibleResource.GetPossibleResourceTest1;
import org.simantics.db.tests.api.readGraph.getPossibleResource.GetPossibleResourceTest2;
import org.simantics.db.tests.api.readGraph.getPossibleURI.GetPossibleURITest1;
import org.simantics.db.tests.api.readGraph.getPredicates.GetPredicatesTest1;
import org.simantics.db.tests.api.readGraph.getPredicates.GetPredicatesTest2;
import org.simantics.db.tests.api.readGraph.getPredicates.GetPredicatesTest3;
import org.simantics.db.tests.api.readGraph.getPredicates.GetPredicatesTest4;
import org.simantics.db.tests.api.readGraph.getPredicates.GetPredicatesWithAssertionsTest6;
import org.simantics.db.tests.api.readGraph.getPredicates.PredicatePropertiesTest;
import org.simantics.db.tests.api.readGraph.getPrincipalTypes.GetPrincipalTypesTest1;
import org.simantics.db.tests.api.readGraph.getPrincipalTypes.GetPrincipalTypesTest2;
import org.simantics.db.tests.api.readGraph.getPrincipalTypes.GetPrincipalTypesTest3;
import org.simantics.db.tests.api.readGraph.getRelatedValue.GetRelatedValueTest1;
import org.simantics.db.tests.api.readGraph.getRelatedValue.GetRelatedValueTest10;
import org.simantics.db.tests.api.readGraph.getRelatedValue.GetRelatedValueTest2;
import org.simantics.db.tests.api.readGraph.getRelatedValue.GetRelatedValueTest23;
import org.simantics.db.tests.api.readGraph.getRelatedValue.GetRelatedValueTest24;
import org.simantics.db.tests.api.readGraph.getRelatedValue.GetRelatedValueTest25;
import org.simantics.db.tests.api.readGraph.getRelatedValue.GetRelatedValueTest26;
import org.simantics.db.tests.api.readGraph.getRelatedValue.GetRelatedValueTest27;
import org.simantics.db.tests.api.readGraph.getRelatedValue.GetRelatedValueTest28;
import org.simantics.db.tests.api.readGraph.getRelatedValue.GetRelatedValueTest29;
import org.simantics.db.tests.api.readGraph.getRelatedValue.GetRelatedValueTest3;
import org.simantics.db.tests.api.readGraph.getRelatedValue.GetRelatedValueTest4;
import org.simantics.db.tests.api.readGraph.getRelatedValue.GetRelatedValueTest5;
import org.simantics.db.tests.api.readGraph.getRelatedValue.GetRelatedValueTest6;
import org.simantics.db.tests.api.readGraph.getRelatedValue.GetRelatedValueTest7;
import org.simantics.db.tests.api.readGraph.getRelatedValue.GetRelatedValueTest8;
import org.simantics.db.tests.api.readGraph.getRelatedValue.GetRelatedValueTest9;
import org.simantics.db.tests.api.readGraph.getResource.GetResourceTest1;
import org.simantics.db.tests.api.readGraph.getResource.GetResourceTest10;
import org.simantics.db.tests.api.readGraph.getResource.GetResourceTest11;
import org.simantics.db.tests.api.readGraph.getResource.GetResourceTest12;
import org.simantics.db.tests.api.readGraph.getResource.GetResourceTest13;
import org.simantics.db.tests.api.readGraph.getResource.GetResourceTest14;
import org.simantics.db.tests.api.readGraph.getResource.GetResourceTest2;
import org.simantics.db.tests.api.readGraph.getResource.GetResourceTest3;
import org.simantics.db.tests.api.readGraph.getResource.GetResourceTest4;
import org.simantics.db.tests.api.readGraph.getResource.GetResourceTest5;
import org.simantics.db.tests.api.readGraph.getResource.GetResourceTest6;
import org.simantics.db.tests.api.readGraph.getResource.GetResourceTest7;
import org.simantics.db.tests.api.readGraph.getResource.GetResourceTest8;
import org.simantics.db.tests.api.readGraph.getResource.GetResourceTest9;
import org.simantics.db.tests.api.readGraph.getSingleObject.GetSingleObjectTest1;
import org.simantics.db.tests.api.readGraph.getSingleObject.GetSingleObjectTest2;
import org.simantics.db.tests.api.readGraph.getSingleObject.GetSingleObjectTest21;
import org.simantics.db.tests.api.readGraph.getSingleObject.GetSingleObjectTest22;
import org.simantics.db.tests.api.readGraph.getSingleObject.GetSingleObjectTest23;
import org.simantics.db.tests.api.readGraph.getSingleObject.GetSingleObjectTest3;
import org.simantics.db.tests.api.readGraph.getSingleObject.GetSingleObjectTest3_bak;
import org.simantics.db.tests.api.readGraph.getSingleStatement.GetSingleStatementTest21;
import org.simantics.db.tests.api.readGraph.getSingleStatement.GetSingleStatementTest22;
import org.simantics.db.tests.api.readGraph.getSingleStatement.GetSingleStatementTest23;
import org.simantics.db.tests.api.readGraph.getSingleStatement.GetSingleStatementTest3;
import org.simantics.db.tests.api.readGraph.getSingleType.GetSingleTypeTest1;
import org.simantics.db.tests.api.readGraph.getSingleType.GetSingleTypeTest2;
import org.simantics.db.tests.api.readGraph.getSingleType.GetSingleTypeTest3;
import org.simantics.db.tests.api.readGraph.getSingleType.GetSingleTypeTest7;
import org.simantics.db.tests.api.readGraph.getStatements.GetStatementsTest1;
import org.simantics.db.tests.api.readGraph.getStatements.GetStatementsTest2;
import org.simantics.db.tests.api.readGraph.getStatements.GetStatementsTest3;
import org.simantics.db.tests.api.readGraph.getStatements.GetStatementsTest4;
import org.simantics.db.tests.api.readGraph.getStatements.GetStatementsTest5;
import org.simantics.db.tests.api.readGraph.getStatements.GetStatementsTest6;
import org.simantics.db.tests.api.readGraph.getStatements.GetStatementsTest7;
import org.simantics.db.tests.api.readGraph.getStatements.GetStatementsWithAssertionsTest3;
import org.simantics.db.tests.api.readGraph.getStatements.GetStatementsWithAssertionsTest6;
import org.simantics.db.tests.api.readGraph.getStatements.GetStatementsWithAssertionsTest7;
import org.simantics.db.tests.api.readGraph.getSuperRelations.GetSuperrelationsTest1;
import org.simantics.db.tests.api.readGraph.getSuperRelations.GetSuperrelationsTest2;
import org.simantics.db.tests.api.readGraph.getSuperRelations.GetSuperrelationsTest3;
import org.simantics.db.tests.api.readGraph.getSuperRelations.GetSuperrelationsTest4;
import org.simantics.db.tests.api.readGraph.getSuperTypes.GetSupertypesTest1;
import org.simantics.db.tests.api.readGraph.getSuperTypes.GetSupertypesTest2;
import org.simantics.db.tests.api.readGraph.getSuperTypes.GetSupertypesTest3;
import org.simantics.db.tests.api.readGraph.getSuperTypes.GetSupertypesTest7;
import org.simantics.db.tests.api.readGraph.getTypes.GetTypesTest1;
import org.simantics.db.tests.api.readGraph.getTypes.GetTypesTest2;
import org.simantics.db.tests.api.readGraph.getTypes.GetTypesTest3;
import org.simantics.db.tests.api.readGraph.getTypes.GetTypesTest7;
import org.simantics.db.tests.api.readGraph.getURI.GetURITest1;
import org.simantics.db.tests.api.readGraph.getValue.GetValueTest1;
import org.simantics.db.tests.api.readGraph.getValue.GetValueTest2;
import org.simantics.db.tests.api.readGraph.getValue.GetValueTest22;
import org.simantics.db.tests.api.readGraph.getValue.GetValueTest23;
import org.simantics.db.tests.api.readGraph.getValue.GetValueTest24;
import org.simantics.db.tests.api.readGraph.getValue.GetValueTest25;
import org.simantics.db.tests.api.readGraph.getValue.GetValueTest26;
import org.simantics.db.tests.api.readGraph.getValue.GetValueTest3;
import org.simantics.db.tests.api.readGraph.getValue.GetValueTest4;
import org.simantics.db.tests.api.readGraph.getValue.GetValueTest5;
import org.simantics.db.tests.api.readGraph.getValue.GetValueTest6;
import org.simantics.db.tests.api.readGraph.hasStatement.HasStatementTest1;
import org.simantics.db.tests.api.readGraph.hasStatement.HasStatementTest2;
import org.simantics.db.tests.api.readGraph.hasValue.HasValueTest1;
import org.simantics.db.tests.api.readGraph.isInheritedFrom.IsInheritedFromTest1;
import org.simantics.db.tests.api.readGraph.isInstanceOf.IsInstanceOfTest1;
import org.simantics.db.tests.api.readGraph.isSubrelationOf.IsSubrelationOfTest1;

@RunWith(RegressionSuiteRunner.class)
@SuiteClasses({
    AdaptionFailureTest.class,
    AdaptTest3.class,
    AdaptTest4.class,
    AdaptRelatedTest2.class,
    AdaptRelatedTest3.class,
    AdaptUniqueTest2.class,
    ForEachObjectTest1.class,
    ForObjectSetTest1.class,
    GetAssertedObjectsTest1.class,
    GetAssertedObjectsTest2.class,
    GetAssertedObjectsTest3.class,
    GetAssertedObjectsTest4.class,
    GetAssertedObjectsTest5.class,
    GetAssertedObjectsTest6.class,
    GetAssertedObjectsTest7.class,
    GetAssertedStatementsTest1.class,
    GetAssertedStatementsTest2.class,
    GetAssertedStatementsTest3.class,
    GetAssertedStatementsTest4.class,
    GetAssertedStatementsTest5.class,
    GetAssertedStatementsTest6.class,
    GetAssertedStatementsTest7.class,
    GetBuiltinTest1.class,
    GetInverseTest1.class,
    GetInverseTest2.class,
    GetInverseTest3.class,
    GetInverseTest4.class,
    GetObjectsTest1.class,
    GetObjectsTest21.class,
    GetObjectsTest22.class,
    GetObjectsTest3.class,
    GetObjectsTest4.class,
    GetObjectsTest5.class,
    GetObjectsTest6.class,
    GetObjectsTest7.class,
    GetObjectsWithAssertionsTest3.class,
    GetObjectsWithAssertionsTest6.class,
    GetObjectsWithAssertionsTest7.class,
    GetPossibleResourceTest1.class,
    GetPossibleResourceTest2.class,
    GetPossibleURITest1.class,
    GetPredicatesTest1.class,
    GetPredicatesTest2.class,
    GetPredicatesTest3.class,
    GetPredicatesTest4.class,
    GetPredicatesWithAssertionsTest6.class,
    PredicatePropertiesTest.class,
    GetPrincipalTypesTest1.class,
    GetPrincipalTypesTest2.class,
    GetPrincipalTypesTest3.class,
    GetRelatedValueTest1.class,
    GetRelatedValueTest10.class,
    GetRelatedValueTest2.class,
    GetRelatedValueTest23.class,
    GetRelatedValueTest24.class,
    GetRelatedValueTest25.class,
    GetRelatedValueTest26.class,
    GetRelatedValueTest27.class,
    GetRelatedValueTest28.class,
    GetRelatedValueTest29.class,
    GetRelatedValueTest3.class,
    GetRelatedValueTest4.class,
    GetRelatedValueTest5.class,
    GetRelatedValueTest6.class,
    GetRelatedValueTest7.class,
    GetRelatedValueTest8.class,
    GetRelatedValueTest9.class,
    GetResourceTest1.class,
    GetResourceTest10.class,
    GetResourceTest11.class,
    GetResourceTest12.class,
    GetResourceTest13.class,
    GetResourceTest14.class,
    GetResourceTest2.class,
    GetResourceTest3.class,
    GetResourceTest4.class,
    GetResourceTest5.class,
    GetResourceTest6.class,
    GetResourceTest7.class,
    GetResourceTest8.class,
    GetResourceTest9.class,
    GetSingleObjectTest1.class,
    GetSingleObjectTest2.class,
    GetSingleObjectTest21.class,
    GetSingleObjectTest22.class,
    GetSingleObjectTest23.class,
    GetSingleObjectTest3_bak.class,
    GetSingleObjectTest3.class,
    GetSingleStatementTest21.class,
    GetSingleStatementTest22.class,
    GetSingleStatementTest23.class,
    GetSingleStatementTest3.class,
    GetSingleTypeTest1.class,
    GetSingleTypeTest2.class,
    GetSingleTypeTest3.class,
    GetSingleTypeTest7.class,
    GetStatementsTest1.class,
    GetStatementsTest2.class,
    GetStatementsTest3.class,
    GetStatementsTest4.class,
    GetStatementsTest5.class,
    GetStatementsTest6.class,
    GetStatementsTest7.class,
    GetStatementsWithAssertionsTest3.class,
    GetStatementsWithAssertionsTest6.class,
    GetStatementsWithAssertionsTest7.class,
    GetSuperrelationsTest1.class,
    GetSuperrelationsTest2.class,
    GetSuperrelationsTest3.class,
    GetSuperrelationsTest4.class,
    GetSupertypesTest1.class,
    GetSupertypesTest2.class,
    GetSupertypesTest3.class,
    GetSupertypesTest7.class,
    GetTypesTest1.class,
    GetTypesTest2.class,
    GetTypesTest3.class,
    GetTypesTest7.class,
    GetURITest1.class,
    GetValueTest1.class,
    GetValueTest2.class,
    GetValueTest22.class,
    GetValueTest23.class,
    GetValueTest24.class,
    GetValueTest25.class,
    GetValueTest26.class,
    GetValueTest3.class,
    GetValueTest4.class,
    GetValueTest5.class,
    GetValueTest6.class,
    HasStatementTest1.class,
    HasStatementTest2.class,
    HasValueTest1.class,
    IsInheritedFromTest1.class,
    IsInstanceOfTest1.class,
    IsSubrelationOfTest1.class
})
public class SuiteReadGraph {

	@BeforeClass
    public static void setUp() {
		try {
			Tests.freshDatabase();
		} catch (Exception e) {
			Logger.defaultLogError(e);
		}
    }
	
}
