/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.api.readGraph.getRelatedValue;

import org.simantics.databoard.Bindings;
import org.simantics.db.ReadGraph;
import org.simantics.db.WriteGraph;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.testing.base.WriteReadTest;
import org.simantics.db.tests.api.readGraph.common.Ontologies;

public class GetRelatedValueTest23 extends WriteReadTest {

    @Override
    protected void write(WriteGraph graph) throws DatabaseException {
        written = Ontologies.relatedConsiststOfString(L0, graph);
    }
    
    @Override
    protected void read(ReadGraph graph) throws DatabaseException {
    	try {
            assertNotNull("Null not allowed", graph.getRelatedValue(written, L0.ConsistsOf, Bindings.STRING));
        } catch (Exception e) {
        	fail("Exception: " + e.getClass().getCanonicalName());
        }
    }
}