/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.api.readGraph.getRelatedValue;

import org.simantics.databoard.Bindings;
import org.simantics.db.ReadGraph;
import org.simantics.db.Resource;
import org.simantics.db.WriteGraph;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.exception.ServiceException;
import org.simantics.db.testing.base.WriteReadTest;

public class GetRelatedValueTest26 extends WriteReadTest {
	private Resource instance;
	private Resource type;
    private float val[] = {0.1F, 0.2F};
 
    @Override
    protected void write(WriteGraph graph) throws DatabaseException {
        instance = graph.newResource();
        type = graph.newResource();
        graph.claim(instance, L0.InstanceOf, null,  L0.DoubleArray);
        graph.claimValue(instance, val);
        graph.claim(type, L0.ConsistsOf, instance);
    }
    
    @Override
    protected void read(ReadGraph graph) throws DatabaseException {
    	try {
            assertNotNull("Null not allowed", graph.getRelatedValue(type, L0.ConsistsOf, Bindings.DOUBLE_ARRAY));
    	} catch (ServiceException e) {
    		return;
    	} catch (Exception e) {
        	fail("Wrong exception: " + e.getClass().getCanonicalName());
        }
    	fail("Should throw.");
    }
}