/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.api.readGraph.getSuperRelations;

import java.util.Set;

import org.simantics.db.ReadGraph;
import org.simantics.db.Resource;
import org.simantics.db.WriteGraph;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.testing.base.WriteReadTest;

public class GetSuperrelationsTest4 extends WriteReadTest {
	private Resource relation1;
	private Resource relation2;

	@Override
    protected void write(WriteGraph graph) throws DatabaseException {
    	
        relation1 = graph.newResource();
        relation2 = graph.newResource();

        graph.claim(relation1, L0.InstanceOf, L0.Relation);

        graph.claim(relation2, L0.SubrelationOf, relation1);
        

	}
	@Override
    protected void read(ReadGraph graph) throws DatabaseException {
    	
        Set<Resource> results = graph.getSuperrelations(relation2);
        int resultsSize = results.size();
        //for (Resource r: results) {
        //	System.out.println(TestingUtils.predicateName(L0, graph, r));
        //}
       
        assertTrue("Wrong number of relations" + resultsSize,
        		(resultsSize == 1));
        //assertTrue(Tests.contains(statements, L0.SupertypeOf, named1));
        //ssertTrue(Tests.contains(statements, L0.SupertypeOf, named2));
        
        
    }
	
}
