/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.api.readGraph.hasStatement;

import org.junit.Test;
import org.simantics.db.ReadGraph;
import org.simantics.db.Session;
import org.simantics.db.common.request.ReadRequest;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.testing.base.SimpleBase;
import org.simantics.layer0.Layer0;

public class HasStatementTest1 extends SimpleBase {
	@Test
    public void testHasStatement() throws DatabaseException {
        final Session s = getSession();
        hasStm1(s);
        hasStm2(s);
        hasStm3(s);
    }
    private void hasStm1(Session s) throws DatabaseException {
        s.syncRequest(new ReadRequest() {
            @Override
            public void run(ReadGraph g) throws DatabaseException {
                Layer0 l0 = Layer0.getInstance(g);
//              assertFalse(g.hasStatement(null));
                assertTrue(g.hasStatement(rl));
                assertTrue(g.hasStatement(l0.Entity));
                assertTrue(g.hasStatement(l0.Relation));
                assertTrue(g.hasStatement(l0.Literal));
                assertTrue(g.hasStatement(l0.True));
            }
        });
    }
    private void hasStm2(Session s) throws DatabaseException {
        s.syncRequest(new ReadRequest() {
            @Override
            public void run(ReadGraph g) throws DatabaseException {
                Layer0 l0 = Layer0.getInstance(g);
//              assertFalse(g.hasStatement(null, null));
//              assertFalse(g.hasStatement(rl, null));
                assertFalse(g.hasStatement(rl, rl));
                assertTrue(g.hasStatement(l0.Entity, l0.InstanceOf));
                assertTrue(g.hasStatement(l0.Entity, l0.HasProperty));
                assertFalse(g.hasStatement(l0.Entity, l0.SubrelationOf));
                assertFalse(g.hasStatement(l0.Entity, l0.SuperrelationOf));
            }
        });
    }
    private void hasStm3(Session s) throws DatabaseException {
        s.syncRequest(new ReadRequest() {
            @SuppressWarnings("deprecation")
            @Override
            public void run(ReadGraph g) throws DatabaseException {
                Layer0 l0 = Layer0.getInstance(g);
//              assertFalse(g.hasStatement(null, null, null));
                assertFalse(g.hasStatement(rl, rl, rl));
                assertFalse(g.hasStatement(rl, l0.InstanceOf, l0.Property));
                assertTrue(g.hasStatement(rl, l0.InstanceOf, l0.Library));
            }
        });
    }
}