/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.api.support.clusterControl;

import org.junit.Test;
import org.simantics.db.Resource;
import org.simantics.db.WriteGraph;
import org.simantics.db.common.request.WriteRequest;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.service.ClusterControl;
import org.simantics.db.testing.base.ExistingDatabaseTest;

/**
 * 
 * @author Antti Villberg
 *
 */
public class ClaimIntoNewResourceAfterIntermediateClusterCollect extends ExistingDatabaseTest {
	
	@Test
	public void test() throws Exception{

		getSession().syncRequest(new WriteRequest() {
		    @Override
		    public void perform(WriteGraph graph) throws DatabaseException {

		    	// Start new cluster
		        graph.flushCluster();
		        
		        // Create some resources
		        for(int i=0;i<1000;i++) graph.newResource();
		        
		        // Create and store a resource
		        Resource target = graph.newResource();

		        // Flush clusters including the one just created
		        getSession().getService(ClusterControl.class).collectClusters(Integer.MAX_VALUE);

		        // Write into the stored resource
		        graph.claim(target, target, target);
		        
		    }
		});
		
	}

}
