/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.api.support.transferableGraphSupport;

import java.io.IOException;
import java.util.Arrays;

import org.junit.Test;
import org.simantics.databoard.Bindings;
import org.simantics.databoard.binding.Binding;
import org.simantics.databoard.serialization.SerializationException;
import org.simantics.databoard.serialization.Serializer;
import org.simantics.databoard.serialization.SerializerConstructionException;
import org.simantics.db.ReadGraph;
import org.simantics.db.Resource;
import org.simantics.db.Session;
import org.simantics.db.common.request.ReadRequest;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.service.TransferableGraphSupport;
import org.simantics.db.testing.annotation.Fails;
import org.simantics.db.testing.base.ExistingDatabaseTest;
import org.simantics.layer0.Layer0;

public class TransferableGraphSupportTest1 extends ExistingDatabaseTest {

    @Test
    @Fails
    public void test() throws Exception {

        Session session = getSession();
        final TransferableGraphSupport support = session.getService(TransferableGraphSupport.class);

        try {
            session.syncRequest(new ReadRequest() {
                @Override
                public void run(ReadGraph g) throws DatabaseException {
                    // Use any non-functional relation
                    Layer0 b = Layer0.getInstance(g);
                    Resource name = g.getSingleObject(g.getRootLibrary(), b.HasName);
                    Object value = g.getValue(name);
                    Binding binding = Bindings.STRING;
                    try {
                        Serializer serializer = Bindings.getSerializer( binding );
                        byte[] data = serializer.serialize(value);
                        byte[] raw = support.getValue(g, name);
                        assert(Arrays.equals(data, raw));
                    } catch (SerializerConstructionException e) {
                        throw new Error(e);
                    } catch (SerializationException e) {
                        throw new Error(e);
                    } catch (IOException e) {
                        throw new Error(e);
                    }
                }
            });
        } catch (Throwable e) {
            fail("Write transaction threw an unknown exception ", e);
        }

    }

}
