/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.client;

import org.junit.Test;
import org.simantics.db.ReadGraph;
import org.simantics.db.Resource;
import org.simantics.db.Session;
import org.simantics.db.WriteGraph;
import org.simantics.db.common.request.WriteRequest;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.request.Read;
import org.simantics.db.service.XSupport;
import org.simantics.db.testing.annotation.Fails;
import org.simantics.db.testing.base.ExistingDatabaseTest;

public class JournalTestFail extends ExistingDatabaseTest {

    @Test
    @Fails
    public void testJournalFail() throws DatabaseException{
        final Session s = getSession();
        s.syncRequest(new WriteRequest() {
            @Override
            public void perform(WriteGraph g) throws DatabaseException {
                XSupport xs = (XSupport)g.getService(XSupport.class);
                xs.corruptCluster(null);
                xs.flushCluster(null);
            }
        });
        if (DEBUG)
            System.out.println("Write done.");
        s.syncRequest(new Read<Resource>() {
            @Override
            public Resource perform(ReadGraph g) throws DatabaseException {
                return null;
            }
        });
    }
}