package org.simantics.db.tests.client;

import org.junit.Test;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.testing.base.TestCommonNoVirtual;
import org.simantics.db.testing.common.Client;
import org.simantics.db.testing.common.ClientFactory;
import org.simantics.db.tests.common.ClientOperations;
import org.simantics.db.tests.common.Configuration;

public class RefreshTest2 extends TestCommonNoVirtual {
    private static final int COUNT = Configuration.get().refreshLoopCount;
    
    @Test
    public void testRefresh2() throws DatabaseException {
        if (noVirtual())
            return;
        for (int i=0; i<COUNT; ++i) {
            refreshTestRemove();
        }
    }
    void refreshTestRemove() throws DatabaseException {
//        ServerAddress serverAddress = getSessionContext().getAddress();
        Client client1 = ClientFactory.create(getRandomString());
        Client client2 = ClientFactory.create(getRandomString());
        try {
            String name = ClientOperations.createData(client1);
            ClientOperations.validateData(client1, name);
            ClientOperations.validateData(client2, name);
            ClientOperations.removeData(client2, name);
            ClientOperations.validateDataRemoved(client2, name);
            ClientOperations.validateDataRemoved(client1, name);
            name = ClientOperations.createData(client2);
            ClientOperations.validateData(client1, name);
            ClientOperations.validateData(client2, name);
            ClientOperations.removeData(client1, name);
            ClientOperations.validateDataRemoved(client1, name);
            ClientOperations.validateDataRemoved(client2, name);
        } finally {
            if (null != client1)
                client1.close();
            if (null != client2)
                client2.close();
        }
    }
}
