/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.client;


import org.junit.Test;
import org.simantics.db.WriteGraph;
import org.simantics.db.common.request.WriteRequest;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.service.DebugSupport;
import org.simantics.db.testing.base.TestCommonNoVirtual;
import org.simantics.db.testing.common.Client;
import org.simantics.db.testing.common.ClientFactory;

@SuppressWarnings("deprecation") // No replacement given so now way to fix this error.
public class ReserveIdsTest2 extends TestCommonNoVirtual {

    private String nextId;
    
    @Test
    public void test() throws DatabaseException {
//        ServerAddress serverAddress = getSessionContext().getAddress();
        String clientId = getRandomString();
        Client client1 = ClientFactory.create(clientId);
        try {
            client1.getSession().syncRequest(new WriteRequest() {
                @Override
                public void perform(WriteGraph graph) throws DatabaseException {
                    graph.flushCluster();
                    graph.newResource();
                    nextId = graph.getService(DebugSupport.class).query(graph, "print nextId");
                }
            });
        } finally {
            client1.close();
        }
        Client client2 = ClientFactory.create(clientId);
        try {
            client2.getSession().syncRequest(new WriteRequest() {
                @Override
                public void perform(WriteGraph graph) throws DatabaseException {
                    String nextId = graph.getService(DebugSupport.class).query(graph, "print nextId");
                    //assertTrue(nextId.equals(ReserveIdsTest2.this.nextId));
                    int i1 = Integer.parseInt(nextId.substring(0, nextId.indexOf('#')));
                    String t = ReserveIdsTest2.this.nextId;
                    int i2 = Integer.parseInt(t.substring(0, t.indexOf('#')));
                    assertTrue(i1 == i2+1);
                }
            });
        } finally {
            client2.close();
        }
    }
}